﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

namespace MailServer.SMTPServer
{
    public class SmtpPortListener
    {
        private static List<int> Ports { get; set; }
        private int Port { get; set; }
        private TcpListener Listener;
        private List<SmtpServerSession> Sessions { get; set; }

        public SmtpPortListener(int port)
        {
            Sessions = new List<SmtpServerSession>();
            Port = port;
            Thread thread = new Thread(StartListeningAsync);
            thread.Start();
        }

        public async void StartListeningAsync()
        {
            Listener = new TcpListener(IPAddress.Any, Port);
            Listener.Start();

            while (true)
            {
                //var socket = await Listener.AcceptSocketAsync();
                var client = await Listener.AcceptTcpClientAsync();
                var session = new SmtpServerSession(client);
                Sessions.Add(session);
            }
        }
    }
}
